@ECHO OFF
SETLOCAL
cls
Echo.
Echo  - Bankix2Flash                                                        v1.2.1 -
Echo.
Echo Unetbootin ist das von der c't empfohlene Programm, um Bankix auf eine SD-Karte
Echo oder einen USB-Stick zu installieren. Unetbootin ist an sich sehr einfach zu 
Echo bedienen, ersetzt aber das ursprngliche Boot-Men durch ein eigenes, das recht
Echo spartanisch (um nicht zu sagen hsslich) aussieht. Durch dieses Skript ist es
Echo nun mit wenig Aufwand mglich Bankix auf einen USB-Stick oder eine SD-Karte zu
Echo bertragen, den Datentrger bootfhig zu machen und das ursprngliche Boot-Men
Echo zu erhalten. Ganz nebenbei werden gewisse Unzulnglichkeiten, die Unetbootin
Echo und hnliche Programme aufweisen, umgangen.
Echo.
Echo    Ich bernehme keine Verantwortung fr eventuellen Datenverlust, der durch
Echo          falsche Benutzereingaben oder Fehler im Skript entstanden ist.
Echo.
Echo            Die Benutzung dieses Skripts geschieht auf eigene Gefahr!
Echo.
Echo Zum Fortfahren, drcke die Taste [W] fr weiter. Ansonsten [A] fr Abbrechen.
Echo.
CHOICE /C:WA /N /M "Eingabe (W oder A): "

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO ISODETECT

:ISODETECT
If not exist *.iso goto NOISO
If not exist *bankix*.iso goto NOBIXISO
dir /b /o-d *bankix*.iso > iso.txt
Set /p "LINE1="<"iso.txt"

For /F "tokens=* skip=1" %%a IN (iso.txt) DO echo %%a>>line2.txt
IF exist LINE2.txt set /p "LINE2="<"line2.txt"

For /F "tokens=* skip=2" %%a IN (iso.txt) DO echo %%a>>line3.txt
IF exist LINE3.txt set /p "LINE3="<"line3.txt"

For /F "tokens=* skip=3" %%a IN (iso.txt) DO echo %%a>>line4.txt
IF exist LINE4.txt set /p "LINE4="<"line4.txt"

IF not "%LINE2%"=="" GOTO MULTIISO
GOTO ONEISO

:ONEISO
cls
Echo.
Echo Die automatische Erkennung hat folgende Datei gefunden:
Echo.
Echo    -  %LINE1%
Echo.
Echo Ist das die richtige ISO-Datei? 
Echo. 
Echo Das Drcken der Taste [J], fr Ja, fhrt zur Auswahl des Ziellaufwerks. Die
Echo Taste [N], fr Nein, ermglicht die manuelle Eingabe des Dateinames. Mit der
Echo Taste [A], fr Abbrechen, kann das Skript an dieser Stelle beendet werden.
Echo.
CHOICE /C:JNMA /N /M "Eingabe (J, N oder A): "

IF ERRORLEVEL 4 GOTO ABBRUCH
IF ERRORLEVEL 3 GOTO MANUELL
IF ERRORLEVEL 2 GOTO MANUELL
IF ERRORLEVEL 1 GOTO ISO1

:MULTIISO
cls
Echo.
Echo Die automatische Erkennung hat mehrere Bankix.iso Dateien gefunden (bis zu vier
Echo knnen vom Skript erkannt werden). Whle bitte durch Drcken der entsprechenden
Echo Ziffer die Datei aus, die verwendet werden soll:
Echo. 
IF not "%LINE1%"=="" Echo    [1]  %LINE1%
IF not "%LINE2%"=="" Echo    [2]  %LINE2%
IF not "%LINE3%"=="" Echo    [3]  %LINE3%
IF not "%LINE4%"=="" Echo    [4]  %LINE4%
Echo.
Echo Mit der Taste [M] kann auf die manuelle Eingabe des Dateinames umgeschaltet
Echo und mit [A] das Skript an dieser Stelle abgebrochen werden.
Echo.

IF not "%LINE4%"=="" CHOICE /C:MA1234 /N /M "Eingabe (1, 2, 3, 4, M oder A): "
IF exist line4.txt goto ELADMISO
IF not "%LINE3%"=="" CHOICE /C:MA123 /N /M "Eingabe (1, 2, 3, M oder A): "
IF exist line3.txt goto ELADMISO
IF not "%LINE2%"=="" CHOICE /C:MA12 /N /M "Eingabe (1, 2, M oder A): "
IF exist line2.txt goto ELADMISO
IF not "%LINE1%"=="" CHOICE /C:MA1 /N /M "Eingabe (1, M oder A): "
IF exist iso.txt goto ELADMISO
IF "%LINE1%"=="" GOTO ERROR

:ELADMISO
IF ERRORLEVEL 6 GOTO ISO4
IF ERRORLEVEL 5 GOTO ISO3
IF ERRORLEVEL 4 GOTO ISO2
IF ERRORLEVEL 3 GOTO ISO1
IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO MANUELL

:ISO1
SET BixISO=%LINE1%
GOTO SELECTLW

:ISO2
SET BixISO=%LINE2%
GOTO SELECTLW

:ISO3
SET BixISO=%LINE3%
GOTO SELECTLW

:ISO4
SET BixISO=%LINE4%
GOTO SELECTLW

:NOISO
Echo.
Echo Die automatische Erkennung hat keine ISO-Datei gefunden! Die Bankix-ISO-Datei
Echo muss sich im selben Ordner wie das Bix2F-Skript befinden.
GOTO EOF

:NOBIXISO
cls
Echo.
Echo Die automatische Erkennung hat keine Bankix.iso Datei gefunden!
GOTO MANUELL

:MANUELL
Echo.
Echo Gib bitte die exakte Dateibezeichnung inkl. der Dateierweiterung (.iso) ein.
Echo.
Echo Folgende ISO-Dateien befinden sich im Skript-Ordner:
Echo.
dir /b /o-d *.iso
Echo.
SET /P BixISO=Eingabe:
IF not exist %BixISO% GOTO MANERROR
GOTO SELECTLW

:MANERROR
Echo.
Echo Die von dir angegebene Datei existiert nicht.
Echo.
Echo Durch Drcken der Taste [M] kannst du die manuelle Eingabe erneut versuchen.
Echo Mit [A] brichst du das Skript ab.
Echo.
CHOICE /C:MA /N /M "Eingabe (M oder A): "

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO MANUELL

:SELECTLW
cls

Echo LIST DISK > list.txt
Echo EXIT >> list.txt

diskpart /s list.txt
del list.txt

Echo.
Echo Gib bitte die Datentrgernummer des Laufwerks (USB-Stick oder SD-Karte) ein,
Echo auf das Bankix installiert werden soll. Die Nummer des zu verwendenden
Echo Laufwerks ist in der oben angezeigten Auflistung ersichtlich (relativ leicht
Echo zu erkennen an der Gre des Laufwerks).
Echo.
Echo Beachte, dass die Daten auf dem ausgewhlten Laufwerk im spteren Verlauf des
Echo Skripts vollstndig gelscht werden! Eine falsche Eingabe fhrt somit zu
Echo Datenverlust!
Echo. 
SET /P DEV=Eingabe:

Echo SELECT DISK %DEV% > format.txt
Echo CLEAN >> format.txt
Echo CREATE PART PRI >> format.txt
Echo SELECT PART 1 >> format.txt
Echo FORMAT FS=FAT32 LABEL="Bankix" QUICK >> format.txt
Echo ASSIGN LETTER=B >> format.txt
Echo EXIT >> format.txt

GOTO RUN

:RUN
cls
Echo.
Echo Folgende Parameter hast du eingegeben:
Echo.
Echo   Name der Bankix-ISO-Datei: %BixISO%
Echo   Nummer des ausgewhlten Datentrgers: %DEV%
Echo.
Echo Wenn das alles richtig ist, kannst du jetzt mit dem Drcken der Taste [R] das
Echo Formatieren des USB-Sticks / der SD-Karte und das berspielen von Bankix aus-
Echo fhren lassen. 
Echo.
Echo Hierbei wird das ausgewhlte Laufwerk vollstndig gelscht!
Echo.
Echo Mit dem Drcken der Taste [A] kann das Skript jetzt beendet werden.
Echo.
CHOICE /C:RA /N /M "Eingabe (R oder A):"

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO FORMAT

:FORMAT
Echo.
Echo Das ausgewhlte Laufwerk wird mittels Diskpart formatiert...

diskpart /s format.txt > Log.txt
IF %ERRORLEVEL% NEQ 0 GOTO DPERROR
Echo.
Echo Die Formatierung wurde erfolgreich abgeschlossen.
del format.txt

Echo.
Echo Bankix wird auf das ausgewhlte Laufwerk kopiert...
Echo Bitte ein wenig Geduld. Das kann ein paar Minuten dauern.

7z x %BixISO% -oB:\ >> Log.txt
IF ERRORLEVEL 1 SET ERROR=7ZE
IF "%ERROR%"=="7ZE" GOTO 7ZERROR

:SYSLINUX
syslinux.exe -fma -r -d \isolinux B:
IF %ERRORLEVEL% NEQ 0 GOTO SLERROR
copy vesamenu.c32 B:\isolinux\ | Echo j > NUL
pushd B:\
ren "isolinux" "syslinux"
cd syslinux
ren isolinux.cfg syslinux.cfg
del isolinux.bin
popd
Echo.
Echo Der Syslinux Boot-Loader wurde installiert.

Echo SELECT DISK %DEV% > assign.txt
Echo SELECT PART 1 >> assign.txt
Echo ASSIGN >> assign.txt
Echo EXIT >> assign.txt

diskpart /s assign.txt >> Log.txt
IF %ERRORLEVEL% NEQ 0 GOTO AERROR
del assign.txt

IF "%ERROR%"=="7ZE" GOTO 7ZE
GOTO NOERROR

:ABBRUCH
Echo.
Echo Das Skript wurde durch den Benutzer abgebrochen.
GOTO EOF

:ERROR
Echo.
Echo Fehler:
Echo Es ist ein Fehler aufgetreten. Das Skript wurde beendet.
GOTO EOF

:DPERROR
Echo Fehler:
Echo Es ist ein Fehler beim Formatieren aufgetreten.
Echo Das Skript wurde beendet.
GOTO EOF

:AERROR
Echo Fehler:
Echo Es ist ein Fehler beim Zuweisen des Laufwerksbuchstaben aufgetreten.
Echo Das Skript wurde beendet.
GOTO EOF

:SLERROR
Echo.
Echo Fehler:
Echo Es ist ein Fehler beim Schreiben des Boot-Codes aufgetreten.
Echo Das Skript wurde beendet.
GOTO EOF

:7ZERROR
Echo.
Echo Fehler:
Echo Es ist ein Fehler beim Extrahieren der Dateien aus der ISO-Datei aufgetreten.
Echo Es muss kein kritischer Fehler sein und Bankix kann trotzdem funktionieren.
Echo In der Regel wird die (fr die Funktion von Bankix nicht wichtige) Datei
Echo Autorun.inf vom Antivirenprogramm geblockt, wodurch auch diese Fehlermeldung
Echo verursacht wird. 
Echo.
Echo Was genau fr ein Fehler aufgetreten ist, kann in der Datei Log.txt nachgeprft
Echo werden.
GOTO SYSLINUX

:7ZE
Echo.
Echo Bankix wurde vermutlich erfolgreich auf den USB-Stick bzw. die SD-Karte
Echo installiert.
GOTO EOF

:NOERROR
Echo.
Echo Bankix wurde erfolgreich auf den USB-Stick bzw. die SD-Karte installiert.
GOTO EOF

:: - Text-Schablone 
Echo ͼ

:EOF
IF exist assign.txt del assign.txt
IF exist format.txt del format.txt
IF exist iso.txt del iso.txt
IF exist line2.txt del line2.txt
IF exist line3.txt del line3.txt
IF exist line4.txt del line4.txt
ENDLOCAL
Echo.
Echo Das Konsolen-Fenster kann nun geschlossen werden. Entweder mit der Eingabe des
Echo Befehls EXIT oder durch einen Mausklick auf das X in der oberen rechten Ecke
Echo des Fensters.
Echo.
:: Der Aufruf von cmd sorgt dafr, dass das Konsolen-Fenster nach Beendigung des Skripts
:: offen bleibt und man evenutelle Fehlermeldungen lesen kann.
cmd